#!/usr/bin/env python
from ncurses.curses import * # import the curses module
from time import sleep


def main():
  # initialize curses - be sure to assign stdscr to a variable to prevent it
  # from being immediately garbage collected.
  stdscr = initscr()
  cbreak() # provide unbuffered input
  noecho() # turn off input echoing
  nonl() # turn off newline translation
  intrflush(FALSE) # turn off flush-on-interrupt
  keypad(TRUE) # turn on keypad mode

  stdscr.addstr("Press a key to continue") # output string
  stdscr.getch() # get a charachter

  moving(stdscr) # demo of moving cursor
  border(stdscr) # demo of borders
  two_borders() # demo of two windows with borders

def moving(scr):
  scr.clear() # clear screen
  scr.move(5,5) # move cursor
  scr.addstr("move(5,5)")
  scr.refresh() # update screen
  sleep(2)
  scr.move(2,2)
  scr.addstr("move(2,2)")
  scr.refresh()
  sleep(2)
  scr.move(10, 2)
  scr.addstr("Press a key to continue")
  scr.getch()

def border(scr):
  scr.clear()
  scr.line_border() # calls WINDOW.border(0, 0, 0, 0, 0, 0, 0, 0)
  scr.move(3,3)
  scr.addstr("Press a key to continue")
  scr.getch()
  
def two_borders():
  # make a new window as tall as the screen and half as wide, in the left half
  # of the screen
  one = WINDOW(0, COLS() / 2, 0, 0)
  # make one for the right half
  two = WINDOW(0, COLS() - (COLS() / 2), 0, COLS() / 2)
  one.line_border()
  two.line_border()
  one.move(3,3)
  two.move(2,5)
  one.addstr("move(3,3)")
  two.addstr("move(2,5)")
  two.move(5,3)
  two.addstr("Press a key to continue")
  one.noutrefresh() # copy window to virtual screen, don't update real screen
  two.noutrefresh()
  doupdate() # update read screen
  two.getch()

def color_demo():
  start_color() # turn on color mode

main()

