#!/usr/bin/env python
from ncurses.panel import * # import panel module

def main():
  stdscr = initscr() # save stdscr to a variable or it will be GC'ed
  cbreak() # provide unbuffered input
  noecho() # turn off input echoing
  nonl() # turn off newline translation
  intrflush(FALSE) # turn off flush-on-interrupt
  keypad(TRUE) # turn on keypad mode

  stdscr.line_border() # draw border around stdscr
  stdscr.move(LINES() - 2, 2) # write instructions
  stdscr.addstr("Press any key to move windows, CTRL-C to end")

  # make panels
  panels = []
  panels.append(PANEL(LINES() / 3, COLS() / 2, 4, 4))
  panels.append(PANEL(LINES() / 2, COLS() / 3, 3, 25))
  panels.append(PANEL(LINES() / 2, COLS() / 2, 10, 3))

  for each in xrange(len(panels)): # draw in panels
    panels[each].line_border()
    panels[each].move(2,2)
    panels[each].addstr("PANEL " + str(each + 1))

  # cycle panels
  while TRUE:
    for panel in panels:
      panel.top_panel()
      doupdate()
      stdscr.getch()


main()

