#!/usr/bin/env python

"""Setup script for the PyNcurses module distribution."""

__revision__ = "$Id: setup.py,v 1.3 2000/04/23 06:37:34 hgebel Exp $"

from distutils.core import setup

setup (# Distribution meta-data
       name = "pyncurses",
       version = "0.3",
       description = "Ncurses binding for Python",
       author = "Harry Henry Gebel",
       author_email = "hgebel@inet.net",
       url = "http://pyncurses.sourceforge.net",
       licence = '''Copyright (c) 2000 by Harry Henry Gebel

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.''',

       # Description of the modules and packages in the distribution
       packages = ['ncurses'],
       ext_modules = 
           [('ncurses._curses',
             { 'sources': ['ncurses/_curses_wrap.c'],
               'libraries': ['ncurses']
             }),
            ('ncurses._panel',
             { 'sources': ['ncurses/_panel_wrap.c'],
               'libraries': ['panel']
             }),
            ('ncurses._menu',
             { 'sources': ['ncurses/_menu_wrap.c'],
               'libraries': ['menu']
             }),
            ('ncurses._form',
             { 'sources': ['ncurses/_form_wrap.c'],
               'libraries': ['form']
             }),
            ]
      )
